--[[
************************************************************************
Project				: Broker_HitCrit
Author				: zhinjio
Project Revision	: r9
Project Date		: 20081104111947

File				: Broker_HitCrit.lua
Commit Author		: zhinjio
Commit Revision		: 9
Commit Date			: 20081104111947
************************************************************************
Description	:
	Main addon file. 

TODO		:
	Figure out sound notify
	Figure out notify area notify

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

HitCrit_VERSION = 0.1
--HitCrit_DEBUG = false
HitCrit_DEBUG = true

local HitCrit = LibStub( "AceAddon-3.0" ):NewAddon( "HitCrit", "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "HitCrit" )
_G["HitCrit"] = HitCrit

local MODNAME = "HitCrit"
local tooltip
local LTT = LibStub:GetLibrary( "LibTooltip-1.0" )

local db

function HitCrit_Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\Broker_HitCrit\\icon:" .. fh .. "\124t"
	if not ( msg == nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " HitCrit: " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function HitCrit_Debug( msg )
	if not ( msg == nil ) then
		if ( HitCrit_DEBUG ) then
			HitCrit_Print( "DEBUG: " .. msg )
		end
	end
end

function HitCrit_Red( text )
	return "|cffff0000" .. text .. "|r"
end
function HitCrit_Yellow( text )
	return "|cffffff00" .. text .. "|r"
end
function HitCrit_Green( text )
	return "|cff00ff00" .. text .. "|r"
end
function HitCrit_White( text )
	return "|cffffffff" .. text .. "|r"
end
function HitCrit_hit( text)
	return "|cff00ffff" .. text .. "|r"
end
function HitCrit_crit( text)
	return "|cffff8080" .. text .. "|r"
end

function HitCrit:AlertNew( crit, heal, target, spellName, amount )
	local hType, hStr = L["Hit"], L["hit"]
	if ( heal == 1 ) then
		hStr = L["healed"]
		if ( crit == 1 ) then
			hType = L["Critical Heal"]
		else
			hType = L["Heal"]
		end
	else
		if ( crit == 1 ) then
			hType = L["Critical Hit"]
		end
	end
	if ( db.options.alerts.chatframe == true ) then
		HitCrit_Print( string.format( L["New Record %s! %s %s %s for %d"], hType, spellName, hStr, target, amount ) )
	end
	if ( db.options.alerts.notify == true ) then
		UIErrorsFrame:AddMessage( string.format( L["New Record %s! %s %s %s for %d"], hType, spellName, hStr, target, amount ) )
		-- Still need to figure this out
	end
	if ( db.options.alerts.sound == true ) then
		-- Still need to figure this out
		PlaySound("LEVELUPSOUND")
	end
end

function HitCrit_initHC( entry )
	entry.hit = {}; entry.crit = {}
	entry.total = 0
	entry.num = 0
	for i = 1, 3 do
		entry.hit[i] = {}
		entry.hit[i].value = 0
		entry.hit[i].name = ""
		entry.crit[i] = {}
		entry.crit[i].value = 0
		entry.crit[i].name = ""
	end
end

function HitCrit_initSpellEntry()
	local entry = {}
	entry.effect = ""
	entry.school = 0
	entry.rank = 0
	HitCrit_initHC( entry )
	return entry
end

function HitCrit_CheckInsertAlert( heal, id, hit, crit, dName, effect, sch )
	if ( effect ~= "" ) then
		if ( heal == 1 ) then side = "heal" else side = "damage" end
		if ( db.values[side][id] ) then
			local entry = db.values[side][id]
			-- this value already exists. Compare to current, and replace if needed
			if ( crit ~= 0 ) then
				entry.total = entry.total + crit
				entry.num = entry.num + 1
				if ( crit > entry.crit[1].value ) then
					entry.crit[3].value = entry.crit[2].value
					entry.crit[3].name = entry.crit[2].name
					entry.crit[2].value = entry.crit[1].value
					entry.crit[2].name = entry.crit[1].name
					entry.crit[1].value = crit
					entry.crit[1].name = dName
					HitCrit:AlertNew( 1, heal, dName, effect, crit )
				elseif ( crit > entry.crit[2].value ) then
					entry.crit[3].value = entry.crit[2].value
					entry.crit[3].name = entry.crit[2].name
					entry.crit[2].value = crit
					entry.crit[2].name = dName
				elseif ( crit > entry.crit[3].value ) then
					entry.crit[3].value = crit
					entry.crit[3].name = dName
				end
			else
				entry.total = entry.total + hit
				entry.num = entry.num + 1
				if ( hit > entry.hit[1].value ) then
					entry.hit[3].value = entry.hit[2].value
					entry.hit[3].name = entry.hit[2].name
					entry.hit[2].value = entry.hit[1].value
					entry.hit[2].name = entry.hit[1].name
					entry.hit[1].value = hit
					entry.hit[1].name = dName
					HitCrit:AlertNew( 1, heal, dName, effect, hit )
				elseif ( hit > entry.hit[2].value ) then
					entry.hit[3].value = entry.hit[2].value
					entry.hit[3].name = entry.hit[2].name
					entry.hit[2].value = hit
					entry.hit[2].name = dName
				elseif ( hit > entry.hit[3].value ) then
					entry.hit[3].value = hit
					entry.hit[3].name = dName
				end
			end
		else
			-- This could be a previously tracked spell, just with a new rank
			local sName, sRank = GetSpellInfo( id )
			local prevSpellID = 0
			if ( id ~= 0 ) then
				-- sName should match "effect" I believe 
				if ( sName ~= effect ) then HitCrit_Debug( "Spell name (" .. sName .. ") did not match effect (" .. effect ")" ) end
				for k, v in pairs( db.values[side] ) do
					if ( v.effect == sName ) then
						if ( sRank ~= v.rank ) then
							prevSpellID = k
							HitCrit_Debug( "h/id/hit/crit/nm/eff/sch = "..heal.."/"..id.."/"..hit.."/"..crit.."/"..dName.."/"..effect.."/"..sch )
							HitCrit_Debug( "side/sName/rank = "..side.."/"..sName.."/"..rank )
							break
						else
							-- if we're here, someone is casting a downranked spell. Nub.
						end
					end
				end
			end
			if ( prevSpellID ~= 0 ) then
				-- nuke old data
				db.values[side][prevSpellID] = nil
			end

			-- Otherwise, we've got a new previously untracked value. Record all the info
			db.values[side][id] = {}
			local entry = HitCrit_initSpellEntry()
			entry.effect = effect
			entry.school = sch
			entry.rank = sRank
			entry.hit[1].value = hit
			entry.crit[1].value = crit
			if ( crit ~= 0 ) then
				entry.total = crit
				entry.num = 1
				entry.crit[1].name = dName
				HitCrit:AlertNew( 1, heal, dName, effect, crit )
			else
				entry.total = hit
				entry.num = 1
				entry.hit[1].name = dName
				HitCrit:AlertNew( 0, heal, dName, effect, hit )
			end
			db.values[side][id] = entry
		end
	end
end

function HitCrit:COMBAT_LOG_EVENT_UNFILTERED( _, _, eType, sGUID, sName, sFlags, dGUID, dName, dFlags, ... )
-- Parameters:
--	event		COMBAT_LOG_EVENT_UNFILTERED
--	timestamp
--	eType		event type (for example, SPELL_DAMAGE)
--	sGUID		source GUID
--	sName		source Name
--	sFlags		source Flags
--	dGUID		destination GUID
--	dName		destination Name
--	dFlags		destination Flags
--
--		The remaining parameters are dependent on eType
--
--		For RANGE_, SPELL_, SPELL_AURA_ and SPELL_PERIODIC_ prefixes, you have the following
--			spellId
--			spellName
--			spellSchool
--
--		Then, for _DAMAGE suffixes:
--			amount
--			overkill
--			school
--			resisted
--			blocked
--			absorbed
--			critical (1 or nil)
--			glancing (1 or nil)
--			crushing (1 or nil)
--
--		Then, for _HEAL suffixes:
--			amount
--			overhealing
--			critical
--
	local effect, id, hit, crit, sch, heal = "", 0, 0, 0, 0, 0
	if ( sGUID == HitCrit.GUID ) then
		-- First, check for damage
		if ( db.options.tracking.damage ) then
			if ( eType == "SWING_DAMAGE" ) then
				local amount, _, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = school
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_DAMAGE" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, crit, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
		if ( db.options.tracking.healing ) then
			if ( eType == "SWING_HEAL" ) then
				-- does this event exist?
				local amount, overheal, crit = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = 1; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
	elseif ( ( db.options.tracking.againstMe == true ) and ( dGUID == HitCrit.GUID ) ) then
	end
	HitCrit_CheckInsertAlert( heal, id, hit, crit, dName, effect, sch )
end

local LDB = LibStub( "LibDataBroker-1.1" )
local launcher = LDB:NewDataObject( "HitCrit", {
	type = "data source",
	text = "HitCrit",
	label = "Broker_HitCrit",
	icon = "Interface\\Addons\\Broker_HitCrit\\icon",
	OnEnter = function ( self )
		tooltip:Clear()
		local myFont = CreateFont("MyFont")
		if ( db.options.display.fontsize == "small" ) then
			myFont:CopyFontObject(SystemFont_Tiny)
			tooltip:SetFont(myFont)
			myFont:CopyFontObject(SystemFont_Med1)
			tooltip:SetHeaderFont(myFont)
		else
			myFont:CopyFontObject(SystemFont_Small)
			tooltip:SetFont(myFont)
			myFont:CopyFontObject(SystemFont_Med2)
			tooltip:SetHeaderFont(myFont)
		end
		tooltip:AddHeader( HitCrit_White( L["Broker_HitCrit"] ) )
		if ( db.options.display.type ) then
			-- sort by damage school
		else
			tooltip:AddLine( HitCrit_Red( "  " .. L["Damage"] ) )
			tooltip:AddLine( HitCrit_White( "    " .. L["Effect"] ), " ", HitCrit_White( L["Avg"] ), " ",
				HitCrit_White( L["Hit"] ), " ", HitCrit_White( L["Crit"] ) )
			-- loop through damage
			for k, v in pairs( db.values["damage"] ) do
				local e, h, c, a = v.effect, v.hit[1].value, v.crit[1].value, floor( v.total / v.num )
				if ( v.num == 0 ) then a = " " end
				tooltip:AddLine( HitCrit_Yellow( "    " .. e ), " ", HitCrit_Yellow( a ), " ",
					HitCrit_hit( h ), " ", HitCrit_crit( c ) )
			end
			tooltip:AddLine( HitCrit_Green( "  " .. L["Healing"] ) )
			tooltip:AddLine( HitCrit_White( "    " .. L["Effect"] ), " ", HitCrit_White( L["Avg"] ), " ",
				HitCrit_White( L["Hit"] ), " ", HitCrit_White( L["Crit"] ) )
			-- loop through healing
			for k, v in pairs( db.values["heal"] ) do
				local e, h, c, a = v.effect, v.hit[1].value, v.crit[1].value, floor( v.total / v.num )
				if ( v.num == 0 ) then a = " " end
				tooltip:AddLine( HitCrit_Yellow( "    " .. e ), " ", HitCrit_Yellow( a ), " ",
					HitCrit_hit( h ), " ", HitCrit_crit( c ) )
			end
		end
		tooltip:SmartAnchorTo( self )
		tooltip:Show()
	end,
	OnLeave = function ( )
		tooltip:Hide()
	end,
} )

function HitCrit_upgradeDB()
	local olddb = HitCrit.db.factionrealm[HitCrit.me]
	-- This checks the current DB version the person has, and upgrades as necessary
	if not ( olddb.options.display.dbVersion ) then
		-- They have the original version
		local values = {}; values["damage"] = {}; values["heal"] = {}
		local side = "damage"
		for k, v in pairs( olddb.values ) do
			HitCrit_Debug( "id/h/c/dmg/sch/eff = "..k.."/"..v.hit.."/"..v.crit.."/"..
				v.dmg.."/"..v.school.."/"..v.effect )
			if ( v.dmg == 1 ) then side = "damage" else side = "heal" end
			local entry = HitCrit_initSpellEntry()
			_, sRank = GetSpellInfo( k )
			entry.school = v.school
			entry.effect = v.effect
			entry.rank = sRank
			entry.total = 0
			entry.num = 0
			entry.hit[1].value = v.hit
			entry.crit[1].value = v.crit
			if ( v.hit == 0 ) then entry.hit[1].name = "" else entry.hit[1].name = v.target end
			if ( v.crit == 0 ) then entry.crit[1].name = "" else entry.crit[1].name = v.target end
			values[side][k] = entry
		end
		olddb.values = nil
		olddb.values = values
		olddb.options.display.dbVersion = "1.1"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.1" ) )
	elseif ( olddb.options.display.dbVersion == "1.1" ) then
		olddb.options.tracking.lowlevel = false
		olddb.options.display.dbVersion = "1.2"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.2" ) )
	end
end

-- on init
function HitCrit:OnInitialize()
    -- Called when the addon is loaded
	HitCrit.me = UnitName( "player" )
	HitCrit.GUID = UnitGUID( "player" )
	HitCrit.level = UnitLevel( "player" )

	self.db = LibStub( "AceDB-3.0" ):New( "HitCrit_DB", nil, "Default" )
	-- do we have any data yet for this toon? If not, init its table
	if not ( self.db.factionrealm[HitCrit.me] ) then
		self.db.factionrealm[HitCrit.me] = {
			options = {
				tracking = {
					pvp = false,
					againstMe = false,
					damage = true,
					healing = true,
					environmental = false,
					vulnerable = false,
					lowlevel = false,
				},
				display = {
					hit = true,
					crit = true,
					enemyName = false,
					type = false,
					fontsize = "small",
					dbVersion = "1.2",
				},
				alerts = {
					sound = false,
					notify = false,
					chatframe = true,
				},
			},
			values = {
				damage = {},
				heal = {},
			}
		}
	else
		-- check if we need to upgrade the db
		HitCrit_upgradeDB()
	end
	db = self.db.factionrealm[HitCrit.me]

	HitCrit_Debug( "In OnInit" )
	-- Event listeners
    HitCrit:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	tooltip = LTT:Acquire( "HitCritTT", 7, "LEFT", "CENTER", "RIGHT", "CENTER", "RIGHT", "CENTER", "RIGHT" ) -- or GameTooltip

	HitCrit:SetupOptions()
end

--[[
************************************************************************
CHANGELOG:

Date : 10/29/08
	Initial version
************************************************************************
]]--